package main

import (
	"flag"
	"fmt"
	"log"
	"net"
	"strings"
	"sync"

	kyoketsu "git.aetherial.dev/aeth/kyoketsu/pkg"
)

func main() {

	ip := flag.String("ips", "", "single ip address with CIDR notation to gather info about")
	flag.Parse()

	var err error
	var addr *kyoketsu.IpSubnetMapper
	addr, err = kyoketsu.GetNetworkAddresses(*ip)
	if err != nil {
		log.Fatal(err)
	}
	var wg sync.WaitGroup
	for i := range addr.Ipv4s {
		wg.Add(1)
		go func(target string, wg *sync.WaitGroup) {
			defer wg.Done()
			out := kyoketsu.PortWalk(target, kyoketsu.RetrieveScanDirectives().Pairs)
			if len(out.ListeningPorts) > 0 {
				dns, _ := net.LookupAddr(out.IpAddress)
				out.Fqdn = strings.Join(dns, ", ")

				fmt.Printf("%+v\n", out)

			}

		}(addr.Ipv4s[i].String(), &wg)

	}
	wg.Wait()
}
